 package menudemo.handlers;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;
import menudemo.DynamicMenuHelper;
import menudemo.MenuContentDummy;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;

public class RecentFilesHandler {
	
	@Inject
	private MApplication application;
	
	@PostConstruct
	public void init() {
		System.out.println("RecentFilesHandler: init() called. This is: "+this);
		// commenting this in will solve the problem of menu items being created more than once, but 
		// will throw a nullpointer exception when menu items are clicked
		//DynamicMenuHelper.clearMenu(application, "menudemo.recentfiles.menu"); 
		for (final String label : MenuContentDummy.getMenuItemLabels()) {
			DynamicMenuHelper.addMenuItemToMenu(application, "menudemo.recentfiles.menu", 
					label, "bundleclass://MenuDemo/menudemo.handlers.RecentFilesHandler");
		}	
	}
	
	@Execute
	public void execute() {
		// some code ...
		System.out.println("RecentFilesHandler: execute() called. This is: "+this);
	}
	
	@PreDestroy
	public void cleanup() {
		System.out.println("RecentFilesHandler: cleanup() called. This is: "+this);
		DynamicMenuHelper.clearMenu(application, "menudemo.recentfiles.menu"); 
	}
}